

#include <stdio.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/types.h>

#include <string>
#include <iostream>

#include "shared.H"


#define  SHM_KEY  1728


using namespace std;
using namespace avelino;


int main(int argc, char *argv[]) {
	int shmid = shmget(SHM_KEY, sizeof(TShared), IPC_CREAT | IPC_EXCL | 0700);
	if (shmid < 0) {
		perror("shmget");
		return 1;
	}
	cout << "shmid = " << shmid << endl;
	TShared::memArea = shmat(shmid, NULL, 0);
	if (((int) TShared::memArea) == -1) {
		perror("shmat");
		return 1;
	}
	cout << "constructing in shared memory" << endl;
	TShared *p = new TShared();
	cout << "setting a = 12345" << endl;
	p->setA(12345);
	if (shmdt(TShared::memArea) != 0) {
		perror("shmdt");
		return 1;
	}
	/*
	if (shmctl(shmid, IPC_RMID, NULL) != 0) {
		perror("shmctl");
		return 1;
	}
	*/
	cout << "ok" << endl;
	return 0;
}
